/***
  ANZX}N(œK̓RpCɂ΂Ă炤)
  d s*b,u*̎GPRAf*b,d*b̎FPR 鎖B
  $Id: memory.h,v 1.7 2003/01/07 16:44:11 tane Exp $
***/

#define MEM_FETCH    0x00000001
#define MEM_STORE    0x00000002
#define MEM_DACCESS  0x00000010
#define MEM_IACCESS  0x00000020
#define MEM_1B       0x00000100
#define MEM_2B       0x00000200
#define MEM_4B       0x00000400
#define MEM_8B       0x00000800

int          __memaccess_mode ;
unsigned int __ea_for_exception ;
unsigned int __pa_for_exception ;
int          __do_mem_probe ;
unsigned int __mem_probe_pc ;
#define SET_MEM_PROBE()   {__do_mem_probe=__memaccess_mode ;__mem_probe_pc=mres->pc ;}
#define RST_MEM_PROBE()   {__do_mem_probe=0 ;}
#define CHK_MEM_PROBE()   (__do_mem_probe!=0)

#define MEMPROBE_BUFSIZE  32
#define CMP_EA_MODE       0
#define CMP_PA_MODE       1
#define CMP_LD_MODE       2
#define CMP_ST_MODE       4

struct MEMPROBE{
  unsigned int   num ;
  unsigned int   adrs[MEMPROBE_BUFSIZE] ;
  unsigned int   size[MEMPROBE_BUFSIZE] ;
  unsigned int   flag[MEMPROBE_BUFSIZE] ;
  unsigned char *label[MEMPROBE_BUFSIZE] ;
} MemprobeBuf ;
  

#define seg(a)  (((a) & 0xff000000)>>24)
#define lad(a)  ((a) & 0x00ffffff)

#ifdef SUPPORT_MMU_ADRS_TRANSRATION
int	adtr_func( struct MACHINE_RESOURCE *mres , int *pa, unsigned int ea ) ;
#define ADTR(m,p,l)    {int res; if( (res=adtr_func(m,p,(l)))!=NORMAL_EXIT ) return(res) ;}
#define VRAMSTORE4B(ea)
#define VRAMSTORE8B(ea)
#else
#define ADTR(m,p,l)    {*(p)=l ;}
#ifdef SUPPORT_GRAPHIC_DEVICE
#define VRAMSTORE4B(ea)  {if( seg(ea)==GVRAM_SEG_TOP ){\
                            GdevBuf.buf[GdevBuf.c++]=ea ;\
                          }}
#define VRAMSTORE8B(ea)  {if( seg(ea)==GVRAM_SEG_TOP ){\
                            GdevBuf.buf[GdevBuf.c++]=ea ;\
                            GdevBuf.buf[GdevBuf.c++]=ea+4 ;\
                          }}
#else
#define VRAMSTORE4B(ea)
#define VRAMSTORE8B(ea)
#endif
#endif


#define ChkMemRange(m,p,r) {if( (m)->mem_size[seg((p))]>lad((p)) ){r=0;}else{r=-1;}}
#define ChkMemStr(m,p,r) {int i=0 ;\
                          if( (m)->mem[seg((p)+i)]==NULL ){\
                            r=-1;\
                          }else{\
                            while(-1){\
                              if( (m)->mem_size[seg((p)+i)]>lad((p)+i) ){\
                                if( (m)->mem[seg((p)+i)][lad((p)+i)]=='\0' ){\
                                  r=0 ; break ;\
                                }else{i++;}}else{r=-1;break;}}}}



#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_1B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         if( (uc[1]&0x80)!=0 ){\
                           uc[2]=0xff;uc[3]=0xff;\
                         }}
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
	                 uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	ifetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_IACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         float f ;\
                         uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_8B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+7];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+6];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+5];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+4];\
                         uc[4]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[5]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[6]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[7]=mres->mem[seg(ad)][lad(ad)+0];\
                         }

#define	storeu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_1B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
			 }
#define	storeu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[0];\
			 }
#define	storeu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	storef4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         float f;\
                         f=d;uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	stored8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_8B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE8B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[7];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[6];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[5];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[4];\
                         mres->mem[seg(ad)][lad(ad)+4]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+5]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+6]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+7]=uc[0];\
			 }
#else
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_1B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+1];\
                         if( (uc[2]&0x80)!=0 ){\
                           uc[0]=0xff;uc[1]=0xff;\
                         }}
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+0];\
	                 uc[3]=mres->mem[seg(ad)][lad(ad)+1];\
                         }
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         }
#define	ifetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_IACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         }
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         float f ;\
                         uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         d=0;uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_FETCH|MEM_DACCESS|MEM_8B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[4]=mres->mem[seg(ad)][lad(ad)+4];\
                         uc[5]=mres->mem[seg(ad)][lad(ad)+5];\
                         uc[6]=mres->mem[seg(ad)][lad(ad)+6];\
                         uc[7]=mres->mem[seg(ad)][lad(ad)+7];\
                         }

#define	storeu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_1B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
			 }
#define	storeu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_2B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[3];\
			 }
#define	storeu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
			 }
#define	storef4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         float f;\
                         f=d;uc=(unsigned char *)&f;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_4B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE4B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
			 }
#define	stored8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         uc=(unsigned char*)&d;\
                         __memaccess_mode=(MEM_STORE|MEM_DACCESS|MEM_8B);\
                         ADTR(mres,&ad,(a));\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         VRAMSTORE8B(ad);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+4]=uc[4];\
                         mres->mem[seg(ad)][lad(ad)+5]=uc[5];\
                         mres->mem[seg(ad)][lad(ad)+6]=uc[6];\
                         mres->mem[seg(ad)][lad(ad)+7]=uc[7];\
			 }
#endif /**LITTLE_ENDIAN**/

int	memory_copy( struct MACHINE_RESOURCE *, int, int, int ) ;
