/**********************************************************************
  ppmsgR}h PassPointʉߎ̏o̓bZ[W`I
  $Id: ppmsg_cmd.c,v 1.3 2002/11/03 03:57:36 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int ppmsg_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
static unsigned char *msg[]={"only Dump PC",
			     "Dump GPR and others",
			     "Dump all registers",
                             "Dump GPRn",
			     "Dump FPRn",
			     "Dump SPRn" } ;
 
  if( tk_pt->pt[1]==NULL ){
    SYSMSG("Current PassPoint message format is %s\n", msg[ppmsg_stat.msg_type] ) ;
    return(NORMAL_EXIT) ;
  }
  if(       strcmp(tk_pt->pt[1],"pc" )==0 ){
    ppmsg_stat.msg_type  =PP_DUMP_PC ;
    ppmsg_stat.print_type=PRINT_NON  ;
  }else if( strcmp(tk_pt->pt[1],"gpr")==0 ){
    if( tk_pt->pt[2]==NULL ){
      ppmsg_stat.msg_type  =PP_DUMP_GPR ;
      ppmsg_stat.print_type=(PRINT_CRS|PRINT_GPRS) ;
    }else{
      int regno ;
      regno=exatoi(tk_pt->pt[2]) ;
      if( regno<0 || regno>31 ){
	SYSMSG("Invalid GPR No. %d\n",regno ) ;
	return(NORMAL_EXIT) ;
      }
      ppmsg_stat.msg_type  =PP_DUMP_GPR ;
      ppmsg_stat.print_type=(PRINT_GPRn|regno) ;
    }
  }else if( strcmp(tk_pt->pt[1],"all")==0 ){
    ppmsg_stat.msg_type  =PP_DUMP_ALL ;
    ppmsg_stat.print_type=(PRINT_CRS|PRINT_GPRS|PRINT_FPRS) ;
  }else{
    SYSMSG("Invalid argument %s\n",tk_pt->pt[1] ) ;
  }
  
  return(NORMAL_EXIT) ;
}

